#include <iostream>
#include <string>
#include <cctype>
#include <new>
using namespace std;

struct numer
{
	string imie;
	string nazwisko;
	string telefon;

	numer *nastepny;
};

// Prototypy
void dodajTelefon(numer **lista, numer *dane);
numer *znajdzOsobe(numer *lista, string nazwisko);
void usunListe(numer **lista);
void wypiszListe(numer *lista);
numer *wczytajOsobe();
void wypiszOsobe(numer *dane);

int main()
{
numer *lista = NULL;

	cout << "Program utworzy baze numerow telefonicznych" << endl << endl;
	
	cout << "Podaj czynnosc do wykonania:" << endl;
	cout << "d - dodaj wpis do bazy" << endl;
	cout << "s - szukaj osoby o podanym nazwisku" << endl;
	cout << "w - wypisz liste rekordow w bazie" << endl;
	cout << "z - zakoncz dzialanie programu" << endl << endl;

	char o;
	do
	{
		cout << "Podaj czynnosc do wykonania [d/s/w/z]: ";
		cin >> o;
		cout << endl;
		cin.ignore();

		// Zamie na du liter
		o = toupper(o);		
		switch(o)
		{
			case 'D':
				{
					cout << "Wpisz dane nowej osoby w bazie: " << endl <<endl;
					numer *nowy = wczytajOsobe();
					if(nowy != NULL)
						dodajTelefon(&lista, nowy);
					break;
				}
				
			case 'S':
				{
					string szukany;
					
					cout << "Podaj szukane nazwisko: ";
					getline(cin, szukany);
					
					numer *znaleziony = znajdzOsobe(lista, szukany);
					if(znaleziony == NULL)
						cout << "Osoby nie ma w bazie" << endl << endl;
					else
					{
						cout << "Znaleziono nastepujaca osobe:" << endl;
						wypiszOsobe(znaleziony);
						cout << endl;
					}
					break;
				}
				
			case 'W':
				wypiszListe(lista);
				cout << endl;
				break;
				
			case 'Z':
				break;
		
			default:
				cout << "Dopuszczalne opcje to d [dodaj], s [szukaj], w [wypisz] lub z [zakoncz]" << endl;
		}
	}
	while(o != 'Z');
	usunListe(&lista);
}

void dodajTelefon(numer **lista, numer *dane)
{
	if(lista == NULL || dane == NULL) return;
	
	// Jesli lista jest pusta lub nowe nazwisko ma byc pierwsze na liscie...
	if(*lista == NULL || (*lista)->nazwisko > dane->nazwisko)
	{
		// ... dodajemy "dane" na poczatek listy
		dane->nastepny = *lista;
		// "dane" jest obecnie pierwszym elementem
		*lista = dane;
		return;
	}
	else // *lista != NULL && *lista->nazwisko <= dane->nazwisko
	{
		// Znajdujemy poprzednik nowego elementu w tworzonej liscie
		numer *poprzednik = *lista;
		while(	poprzednik->nastepny != NULL &&
				poprzednik->nastepny->nazwisko < dane->nazwisko)
			poprzednik = poprzednik->nastepny;
		
		// Dodawanie elementu za elementem "poprzedni"
		dane->nastepny = poprzednik->nastepny;
		poprzednik->nastepny = dane;
	}
}

numer *znajdzOsobe(numer *lista, string nazwisko)
{
	numer *aktualny = lista;
	while(aktualny != NULL)
	{
		if(aktualny->nazwisko == nazwisko) return aktualny;
		aktualny = aktualny->nastepny;
	}
	// Nie udalo sie znalezienie osoby w ksiazce
	return NULL;
}

void usunListe(numer **lista)
{
	numer *kasowany = *lista;
	while(kasowany != NULL)
	{
		numer *nastepny = kasowany->nastepny;
		delete kasowany;
		kasowany = nastepny;
	}
	*lista = NULL;
}

void wypiszListe(numer *lista)
{
	if(lista == NULL)
		cout << "Lista jest pusta" << endl;
	else
	{
		cout << "Zawartosc bazy telefonow:" << endl << endl;
		unsigned i = 1;
		numer *aktualny = lista;
		while(aktualny != NULL)
		{
			cout << "Osoba nr " << i << endl;;
			wypiszOsobe(aktualny);
			cout << endl;
			
			aktualny = aktualny->nastepny;
			i++;
		}
	}
}

numer *wczytajOsobe()
{
	numer *osoba;
	try {
		osoba = new numer;
	}
	catch(bad_alloc) {
		cout << "Brak pamieci" << endl;
		return NULL;
	}
	
	cout << "Podaj imie: ";
	getline(cin, osoba->imie);
	cout << "Podaj nazwisko: ";
	getline(cin, osoba->nazwisko);
	cout << "Podaj numer: ";
	getline(cin, osoba->telefon);
	cout << endl;
	return osoba;
}

void wypiszOsobe(numer *dane)
{
	if(dane != NULL)
	{
		cout << "Imie: " << dane->imie << endl;
		cout << "Nazwisko: " << dane->nazwisko << endl;
		cout << "Numer: " << dane->telefon << endl;
	}
}
